#include <stdlib.h>
#include <stdio.h>
#include "rlcif.h"               /* include the rlc include file */

static int
tx_packet (int ides, int lay, char flags, char **pkt);

int
main (int argc, char *argv[])
{
  int ides;
  unsigned long addr;		/* base address (host byte order) */
  short port;			/* base layer port # */
  addr_list_t addrl;		/* address list ... */
  rlc_tx_params_t parml;	/* tx parameter list ... */
  int nlayers;			/* number of layers */
  unsigned long period;		/* interpacket time at maximum rate */
  int ttl;			/* transmitting ttl */
  int pktsize;			/* our payload size */
  int have_gui = 1;
  char *geometry = NULL;

  int ret;
    

    /*
    ** now perform parameter initialization ...
    ** (addr, port, nlayers, period, ttl, pktsize)
    */
    /* hoops...  we have harwired values! */
    addr = 0xe0111213;	/* 224.1.2.3 */
    port = 9000;
    nlayers = 5;
    period = 7812;	/* ~ 125ms on the base layer */
    ttl = 127;
    pktsize = 256;

    /*
    ** use consecutive addresses, so
    ** provide only the base address.
    */
    addrl.addrs = &addr;
    addrl.nadd = 1;
    addrl.port = port;
    addrl.ttl = ttl;

    parml.nlay = nlayers;
    parml.mpkts = pktsize;
    parml.Mpkts = pktsize;
    parml.t = period;

    /*
    ** rlc receiver initialization  ...
    ** and possibly library initialization
    */
    if ( (ret = ides = rlc_new(0)) < 0 ||
	(ret = rlc_set_addr (ides, &addrl)) < 0 ||
	(ret = rlc_attach (ides, 0, (void *)&tx_packet)) < 0 ||
	(ret = rlc_tx_setup(ides, &parml)) < 0 ) {
	char *c;
	ret = rlc_error_info(&c);
	fprintf (stderr, "Error %d in protocol initialization (%s)\n", ret, c);
	exit (1);
    }

#ifdef HAVE_UI
    if ( have_gui ) {
	if (geometry)
	    rlc_gui_geometry(ides, geometry);

	if (rlc_gui_enable(ides) < 0)
	    have_gui = 0;        
#if 0
	/* 
	** customize user interface
	*/
	if (rlc_gui_loadtcl(ides, tcl_script) < 0)
	    have_gui = 0;
#endif
    }   
#endif

	
    /*
    ** Try to start ...
    */
    if ((ret = rlc_start(ides)) < 0) {
	char *c;
	ret = rlc_error_info(&c);
	fprintf (stderr, "Error %d in start (%s)\n", ret, c);
	exit (1);
    }

    /*
    ** makes thing go ...
    */
    while (EV_TERMINATE != rlc_getevent(1));

    exit(0);
}


char p[256];
/*
** packet transmission routine ...
*/
static int
tx_packet (int ides, int lay, char flags, char **pkt)
{
  static int count;
    if (count < 100) {
	/*
	** chose the packet .... (p)
	*/
        *pkt = p;
	return (sizeof(p));
    } else
	return (-1);		/* this stops the transmission
				 * and deletes this rlc instance
				 */
    count ++;
}
