
####
# Upcalls
##
# proc set_instance_id {id}	(shared with the sender)
# have_an_error {pi errmsg}	(shared with the sender)
# proc set_limit {lim}
# proc set_current {curr}
# proc set_last {last}
####

####
# Callback
##
# proc limit_notify {lim}
####


###
### global vars
###
set LastLay	-1
set LimitLay	0
set LastCurrent	0
		# it's Kb/s
set BaseRate	16

###
# appearence parameters
###
set indxSize	10
set indySize	15
set indActCol		green
set indInactColNull	lightgrey
set indInactCol		grey
set indInactColOver	darkgrey
set indActColOver	red

proc createSetLimit {w varName custproc args} {
    global BaseRate LimitLay
    $w delete 0 end
    foreach i $args {
	set app [expr $BaseRate * (1 << $i)]
	set app "$app Kb/s"
	$w add radiobutton -label $app -variable $varName -value $i -command \
	    "$custproc $i"
    }
    return $w
}

menubutton .fmenu.conf -text "Set"
menu .fmenu.conf.conf -title "set"
menu .fmenu.conf.conf.limit -title "rate limit"
.fmenu.conf.conf add cascade -label "rate limit"  -menu .fmenu.conf.conf.limit
createSetLimit .fmenu.conf.conf.limit LimitLay set_limit_int 0
.fmenu.conf configure -menu .fmenu.conf.conf

frame .left -bd 2 -relief groove
frame .left.l
frame .left.r
#.left.r.sel configure -bitmap upto
frame .left.r.up -relief groove
frame .left.r.down -relief sunken
label .left.l.lcurrv -text "data rate\n$BaseRate Kb/s" -font $globFonts
set app [expr $BaseRate * (1 << $LimitLay)]
label .left.l.llimv -text "Max\n$app Kb/s" -font $globFonts
canvas .left.l.ca

proc pack_all {} {
	pack .fmenu.conf -side left

	pack .left -fill both -expand 1
	pack .left.l -side left
	pack .left.r -side left -fill y

	pack .left.r.up -side top
	pack .left.r.down -side top
	pack .left.l.ca -side top
	pack .left.l.lcurrv -side top
	pack .left.l.llimv -side top
}

proc set_limit {lim} {
	global LimitLay
	if {$lim >= 0} {set LimitLay $lim}
	limit_set $LimitLay
}

proc set_limit_int {lim} {
	global LimitLay ProtoInstance
	set_limit $lim
#	puts "set_limit_int with $lim"
### callback...
	appcall limit_notify $lim $ProtoInstance
}
proc limit_set {limit} {
	global LimitLay LastCurrent BaseRate ProtoInstance
	set app [expr $BaseRate * (1 << $LimitLay)]
	.left.l.llimv configure -text "Max\n$app Kb/s"
	set_current $LastCurrent
}

proc set_last {last} {
	global LastLay indxSize indySize LastCurrent LimitLay \
		indInactColOver indInactColNull indicat dummyoval
	if {$last != $LastLay} {
		.left.l.ca configure -height [expr ($last + 1) * $indySize] \
			-width [expr ($last + 1) * $indxSize]
		for {set i 0} {$i <= $LastLay} {incr i} {
			.left.l.ca delete $indicat($i)
		}
		for {set i 0} {$i <= $last} {incr i} {
			set indicat($i) [ \
				.left.l.ca create rectangle 0 \
				[expr ($last + 1 - $i) * $indySize] \
				[expr ($last + 1) * $indxSize] \
				[expr ($last - $i) * $indySize] -outline "" ]
		}
		if [info exists dummyoval] {
			.left.l.ca delete $dummyoval
		}
		set dummyoval [ \
			.left.l.ca create oval \
				[expr -4 + (- $last - 1) * $indxSize] \
				4 [expr -4 + ($last + 1) * $indxSize] \
				[expr 4 + 2 * ($last + 1) * $indySize] -fill \
				$indInactColNull -outline "" ]
	}
	set LastLay $last
	set arg "createSetLimit .fmenu.conf.conf.limit LimitLay set_limit_int"
	for {set i $LastLay} {$i >= 0} {set i [expr $i - 1]} {set arg "$arg $i"}
	eval $arg
	set_current $LastCurrent
	pack_all
}

proc set_current {curr} {
	global LastLay LimitLay LastCurrent BaseRate indicat
	global indInactCol indActCol indInactColOver indActColOver
	if {$curr > $LastLay || $curr < 0} {
		return
	}
	set LastCurrent $curr
	for {set i 0} {$i <= $LastLay} {incr i} {
		if {$i <= $curr} {
			if {$i <= $LimitLay} {
				.left.l.ca itemconfigure $indicat($i) -fill \
					$indActCol
			} else {
				.left.l.ca itemconfigure $indicat($i) -fill \
					$indActColOver

			}
		} else {
			if {$i <= $LimitLay} {
				.left.l.ca itemconfigure $indicat($i) -fill \
					$indInactCol
			} else {
				.left.l.ca itemconfigure $indicat($i) -fill \
					$indInactColOver
			}
		}
	}
	set app [expr $BaseRate * (1 << $curr)]
	.left.l.lcurrv configure -text "data rate\n$app Kb/s"
}


#set_last 2
#set_last 9
#set_limit 5
#set_last 7

set_current 0
set_last 0
set_limit 0

